function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import { IconFont } from '@zgfe/business-lib';
import { Select, Space, Tooltip } from 'antd';
import _ from 'lodash';
import React, { useEffect, useState } from 'react';
/**
 * 关联ID
 */
var CorrelationId = function CorrelationId(_ref) {
  var className = _ref.className,
    editId = _ref.editId,
    list = _ref.list,
    fieldType = _ref.fieldType,
    value = _ref.value,
    onChange = _ref.onChange;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    id = _useState2[0],
    setId = _useState2[1];
  var _useState3 = useState(true),
    _useState4 = _slicedToArray(_useState3, 2),
    initing = _useState4[0],
    setIniting = _useState4[1];
  useEffect(function () {
    setId(value);
    setIniting(false);
  }, []);
  useEffect(function () {
    if (onChange) onChange(id);
  }, [id]);
  useEffect(function () {
    if (initing) return;
    setId(undefined);
  }, [fieldType]);
  // 默认不能选择的选项
  var disableList = ['zg_id', 'device_id', 'user_id'];
  var options = list.map(function (item) {
    return _objectSpread(_objectSpread({}, item), {}, {
      showName: item.idAlias || item.idName,
      disabled: fieldType && item.idFieldType !== fieldType || item.id === editId || disableList.includes(item.idName)
    });
  });
  return /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Select, {
    options: options,
    value: id,
    disabled: !fieldType,
    fieldNames: {
      label: 'showName',
      value: 'id'
    },
    className: className,
    showSearch: true,
    filterOption: function filterOption(search, option) {
      return new RegExp(_.escapeRegExp(search), 'i').test((option === null || option === void 0 ? void 0 : option.idAlias) || (option === null || option === void 0 ? void 0 : option.idName) || '');
    },
    onChange: setId,
    placeholder: "\u8BF7\u9009\u62E9\u5173\u8054\u5B57\u6BB5",
    suffixIcon: /*#__PURE__*/React.createElement(IconFont, {
      type: "xiangxia",
      className: "cdp-idmapping-create-icon"
    })
  }), /*#__PURE__*/React.createElement(Tooltip, {
    placement: "right",
    overlayInnerStyle: {
      width: '468px'
    },
    title: "\u300C\u5173\u8054ID\u300D\u7684\u4F5C\u7528\uFF1A\u5C06\u65B0\u5F15\u5165\u7684ID\u4E0EID\u5339\u914D\u8868\u4E2D\u7684ID\u5F62\u6210\u8840\u7F18\u5173\u7CFB\uFF0C\r\n\u6BD4\u5982\u60A8\u60F3\u5C06\u624B\u673A\u53F7\u4F5C\u4E3A\u65B0\u7684ID\u5F15\u5165\u5230\u7CFB\u7EDF\u5F53\u4E2D\uFF0C\u90A3\u4E48\u9700\u8981\u901A\u8FC7\u5173\u8054\r\nID\u7684\u914D\u7F6E\u77E5\u9053\u8981\u7ED9\u54EA\u4E2A\u7528\u6237\u6DFB\u52A0\u624B\u673A\u53F7\u3002"
  }, /*#__PURE__*/React.createElement(IconFont, {
    type: "tishiicon",
    className: "cdp-idmapping-create-icon"
  })));
};
export default CorrelationId;